From 4bd77b65dfda3777ae15771059f18b6ce2c7ad0b Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Dec 13 2020 00:29:20 +0000
Subject: [PATCH 1711/2232] Merge pull request #573 from dtolnay/box


Add Box construction tests
---

diff --git a/tests/ffi/lib.rs b/tests/ffi/lib.rs
index cabcdbc..d6be097 100644
--- a/tests/ffi/lib.rs
+++ b/tests/ffi/lib.rs
@@ -276,6 +276,8 @@ pub mod ffi {
     struct Dag4 {
         dag0: Dag0,
     }
+
+    impl Box<Shared> {}
 }
 
 mod other {
diff --git a/tests/ffi/tests.cc b/tests/ffi/tests.cc
index 2be1e06..2834801 100644
--- a/tests/ffi/tests.cc
+++ b/tests/ffi/tests.cc
@@ -50,6 +50,15 @@ Shared c_return_shared() { return Shared{2020}; }
 ::A::B::ABShared c_return_nested_ns_shared() { return ::A::B::ABShared{2020}; }
 
 rust::Box<R> c_return_box() {
+  Shared shared{0};
+  rust::Box<Shared> box{shared}; // explicit constructor from const T&
+  rust::Box<Shared> other{std::move(shared)}; // explicit constructor from T&&
+  box = other;                                // copy assignment
+  box = std::move(other);                     // move assignment
+  rust::Box<Shared> box2(box);                // copy constructor
+  rust::Box<Shared> other2(std::move(other)); // move constructor
+  rust::Box<Shared>::in_place(shared.z);      // placement static factory
+  rust::Box<Shared>::in_place<size_t>(0);
   return rust::Box<R>::from_raw(cxx_test_suite_get_box());
 }
 

